/**
 * J[ƁB
 * m[}Ɓ{FtBlock
 */
class ColorSudoku : public Sudoku {
public:
	ColorSudoku( int rows, int cols, int mini_block_rows, int mini_block_cols, int maxval);
	~ColorSudoku(){}
	virtual Sudoku* create_clone( const Sudoku* sudoku); // @ŃRs[쐬邽߂Ɏgp,hNXœƎf[^ꍇ͕K쐬ĂB
	void print() const;
	YesNo set_color_block_pos( BoxPos pos[MAXVAL]);	// ňBlock̐Fw肷BF͌ĂяoꂽŎɊUB
	YesNo init_end();
	BoxPos rowcol2pos( int row, int col) { return Sudoku::rowcol2pos( row, col);}

protected:
	ColorSudoku(){}								// create_clone()Ŏgp

private:
	// dlƈBOX2̐Ft邱Ƃo݂B
	// Frbgŕ\B
	// F̃rbg kohobit[] ؗpBāCFԍ1gpB
	int           m_color[ROWS][COLS];
	int           m_num_colors;
};

ColorSudoku::ColorSudoku( int rows, int cols, int mini_block_rows, int mini_block_cols, int maxval) : Sudoku( rows, cols, maxval)
{
	memset( m_color, 0, sizeof(m_color));
	m_num_colors  = 0;
	activate_row_blocks();
	activate_col_blocks();
	activate_mini_blocks( mini_block_rows, mini_block_cols);
	//calc_box_blocks();
}

/**
 * @ŃRs[쐬邽߂Ɏgp,hNXœƎf[^ꍇ͕K쐬ĂB
 */
Sudoku* ColorSudoku::create_clone( const Sudoku* src0)
{
	if( src0 == NULL) {
		ColorSudoku* sudoku = new ColorSudoku();
		return    sudoku->create_clone( this);
	}
	const ColorSudoku* src = (const ColorSudoku*)src0;
	memcpy( m_color, src->m_color, sizeof(m_color));
	m_num_colors  = src->m_num_colors;
	return    Sudoku::create_clone( src0);
}

/**
 * Block̐Fw肷B
 * Block̑SĂBOXw肷B
 */
YesNo ColorSudoku::set_color_block_pos( BoxPos pos[MAXVAL])
{
	int           row, col, i;
	for( i=0; i< m_num_boxes; i++) {
		pos2rowcol( pos[i], row, col);
		if( !exist_box( row, col)) { // w肵BOX݂͑邩?
			return    NO;
		}
	}
	m_num_colors++;
	for( i=0; i< m_num_boxes; i++) {
		pos2rowcol( pos[i], row, col);
		m_color[row][col]   |= kohobit[m_num_colors];
	}
	activate_extra_blocks( pos); // ʂȏ͕KvȂ̂USER_BLOCKłKv͖
	return    YES;
}

YesNo ColorSudoku::init_end()
{
	calc_box_blocks();
	return    Sudoku::init_end();
}

/**
 */
void ColorSudoku::print() const
{
	char          m_rowline[1024];
	{
		int i = 0;
		for( int col=0; col< m_cols; col++) {
			if( col % m_cols_mini_block == 0) m_rowline[i++] = '+';
			m_rowline[i++] = '-'; m_rowline[i++] = '-';
		}
		m_rowline[i++]= '+';
		m_rowline[i]= NIL;
	}

	cstring ss = "EPQRSTUVWX1011121314151617181920212223242526272829303132333435363738394041424344454647484950";
	int           row, col;
	int           n=0;
	for( row=0; row< m_rows; row++) {
		if( row%m_rows_mini_block == 0) ps( "%s\n", m_rowline);
		for( col=0; col< m_cols; col++) {
			if( col%m_cols_mini_block == 0) ps( "|");
			ps( "%-.2s", ss+get_boxval(row,col)*2);
			if( get_boxval(row,col) != BoxValNone) n++;
		}
		ps( "|\n");
	}
	ps( "%s\n", m_rowline);
	ps( "萔 : %d \n", n);
}
