/**
 * 0to9ivB
 * Boxɕ̒l(ۂɂ2肾Ǝv)ݒłƂ낪̐Ƃƍ{IɈႤƂB
 */
class ZeroNineSudoku : public Sudoku {
public:
	ZeroNineSudoku( int rows, int cols, int mini_block_rows, int mini_block_cols, int maxval); // 0to9MINI Block̂ʁBꍇ͕ʓrRXgN^쐬邱ƁB
	~ZeroNineSudoku(){}
	virtual Sudoku* create_clone( const Sudoku* sudoku); // @ŃRs[쐬邽߂Ɏgp,hNXœƎf[^ꍇ͕K쐬ĂB
	YesNo init_another_boxval( int row, int col, BoxVal boxval); // ̏ꏊ2lݒ肵C̒lw肷B
	YesNo init_boxval( int row, int col, BoxVal boxval);
	YesNo init_end();
	YesNo set_boxval( int row, int col, BoxVal boxval);
	void print() const;

protected:
	ZeroNineSudoku(){}							// create_clone()Ŏgp

protected:
	bool          m_have_two_boxval[ROWS][COLS]; // SĂBlockɈ2lBoxB
	bool          m_is_reverse[ROWS][COLS];	// 2lt]ēĂ邩? l1lĂƂɁCm_box[][].m_boxval ɒlꂸCm_another_boxval[][]ɒlB̎m_another_boxval[][]ɓĂ̂2l̂\̂̂ǂB
	BoxVal        m_another_boxval[ROWS][COLS];	// 2lBoxC̒lĂB
};

YesNo ZeroNineSudoku::set_boxval( int row, int col, BoxVal boxval)
{
	mt_assert( exist_box( row, col));
	mt_assert( boxval <= m_maxval);
	if( !exist_box( row, col)) return    NO;
	ps( "set_boxval(%d,%d,%d)\n", row, col, boxval);
	Box&          box = rowcol2box( row, col);
	Koho          koho = box.m_koho;
	if( m_have_two_boxval[row][col]) { // Box2l
		if( m_another_boxval[row][col] == BoxValNone) {
			m_another_boxval[row][col]  = boxval;
			box.m_koho = koho & ~kohobit[boxval];
			ps( "new koho:%d\n", box.m_koho);
		}
		else {
			box.m_boxval  = boxval;
			if( boxval != BoxValNone) box.m_koho  = 0;
		}
	}
	else {												// 1lȂƂ́Ĉ܂ܐݒłB
		box.m_boxval= boxval;
		if( boxval != BoxValNone) box.m_koho  = 0;
	}
	m_num_changed++;
	for( int i=0; i< box.m_num_blocks; i++) {	// BoxSĂBlockŕpB
		Block&      block = blockid2block( box.m_block_id[i]);
		decided( block, row, col, boxval);		// p͂ŌvZB
	}
	return    YES;
}

ZeroNineSudoku::ZeroNineSudoku( int rows, int cols, int mini_block_rows, int mini_block_cols, int maxval) : Sudoku( rows, cols, maxval)
{
	memset( m_have_two_boxval, 0, sizeof(m_have_two_boxval));
	memset( m_is_reverse, 0, sizeof(m_is_reverse));
	memset( m_another_boxval, 0, sizeof(m_another_boxval));
	mt_assert( rows+1 == maxval);
	activate_row_blocks();
	activate_col_blocks();
	activate_mini_blocks( mini_block_rows, mini_block_cols);
	calc_box_blocks();
}

/**
 * @ŃRs[쐬邽߂Ɏgp,hNXœƎf[^ꍇ͕K쐬ĂB
 */
Sudoku* ZeroNineSudoku::create_clone( const Sudoku* src0)
{
	if( src0 == NULL) {
		ZeroNineSudoku* sudoku = new ZeroNineSudoku();
		return    sudoku->create_clone( this);
	}
	const ZeroNineSudoku* src = (const ZeroNineSudoku*)src0;
	memcpy( m_have_two_boxval, src->m_have_two_boxval, sizeof(m_have_two_boxval));
	memcpy( m_is_reverse,      src->m_is_reverse,      sizeof(m_is_reverse)     );
	memcpy( m_another_boxval,  src->m_another_boxval,  sizeof(m_another_boxval) );
	return    Sudoku::create_clone( src0);
}

YesNo ZeroNineSudoku::init_boxval( int row, int col, BoxVal boxval)
{
	mt_assert( exist_box( row, col));
	mt_assert( m_yn_init_end == NO);
	mt_assert( boxval >= 0 && boxval <= m_maxval);
	if( !exist_box( row, col)) return    NO;
	if( boxval < 0 || boxval > m_maxval) return    NO;
	Box&          box = m_box[row][col];
	box.m_boxval= boxval;
	return    YES;
}

/**
 * ̏ꏊ2lݒ肵C̒lw肷B
 */
YesNo ZeroNineSudoku::init_another_boxval( int row, int col, BoxVal boxval)
{
	mt_assert( exist_box( row, col));
	ps( "init_another_boxval(%d,%d,%d)\n", row, col, boxval);
	m_another_boxval[row][col]    = boxval;
	m_have_two_boxval[row][col]   = true;
	Box& box = m_box[row][col];
	box.m_koho = get_all_koho() & ~kohobit[boxval];
	return    YES;
}

/**
 * ݒ肵Box̒lgāČl̍i荞݂BBlockm̏dȂvZB
 */
YesNo ZeroNineSudoku::init_end()
{
	mt_assert( m_yn_init_end == NO);
	calc_intersect_blocks();			// BlockvZB
	// Ֆʂɐݒ肳ꂽlŕpvZB
	BoxVal        boxval[ROWS][COLS] = {0};
	BoxVal        boxval2[ROWS][COLS] = {0};
	int           row, col;
	for( row=0; row< m_rows; row++) {	// ܂̓G[oȂߔՖʂ̐lTB
		for( col=0; col< m_cols; col++) {
			boxval[row][col] = get_boxval( row, col);
			boxval2[row][col] = m_another_boxval[row][col];
			if( boxval[row][col] != BoxValNone) m_is_reverse[row][col] = true; // 1l\Ŏw肳ĂB̌\1lset_boxval()̂ŁC2lڂ݂̑ɍS炸tɂȂB
			m_box[row][col].m_boxval  = BoxValNone;
			m_box[row][col].m_koho  = get_all_koho();
			m_another_boxval[row][col]  = BoxValNone;	// G[oȂ߁Cݒς݂̒llɖ߂Ă
		}
	}
	m_yn_init_end = YES;					// set_boxval()ŃG[oȂ悤ɁCŏI𖾎B
	ps( "number_of_blocks:%d, maxval:%d\n", m_num_blocks, m_maxval);
	for( row=0; row< m_rows; row++) {	// ēxݒ肵B
		for( col=0; col< m_cols; col++) {
			set_boxval( row, col, boxval[row][col]);
			if( boxval2[row][col] != BoxValNone) set_boxval( row, col, boxval2[row][col]);
		}
	}
	print();
	dump_koho();
	return    YES;
}

/**
 */
void ZeroNineSudoku::print() const
{
	//--------------------------------------------------------------------
	// ̋`o͂ƂɌhǂ邽߂ɐݒ肵ĂB
	// +------+------+------+ <= ̕
	// |PEE|VEE|UEE|
	// |EQE|EEE|ETE|
	// |EER|EEX|EEE|
	// +------+------+------+ <= ̕
	// |VEE|SEE|EEW|
	// |EEE|ETE|EQE|
	// |EEE|EEU|PEE|
	// +------+------+------+
	// |SEQ|PEE|VEE|
	// |EEE|EEV|EWE|
	// |EEE|EQE|EEX|
	// +------+------+------+
	//--------------------------------------------------------------------
	char          m_rowline[1024];
	{
		int i = 0;
		for( int col=0; col< m_cols; col++) {
			if( col % m_cols_mini_block == 0) m_rowline[i++] = '+';
			m_rowline[i++] = '-'; m_rowline[i++] = '-';
		}
		m_rowline[i++]= '+';
		m_rowline[i]= NIL;
	}

	cstring ss = "EPQRSTUVWX1011121314151617181920212223242526272829303132333435363738394041424344454647484950";
	int           row, col;
	int           n=0;
	for( row=0; row< m_rows; row++) {
		if( row%m_rows_mini_block == 0) ps( "%s\n", m_rowline);
		for( col=0; col< m_cols; col++) {
			if( col%m_cols_mini_block == 0) ps( "|");
			if( m_have_two_boxval[row][col]) {
				BoxVal  boxval1 = get_boxval( row, col);
				BoxVal  boxval2 = m_another_boxval[row][col];
				if( m_is_reverse[row][col]) swap( boxval1, boxval2);
				if( boxval1 == 10) ps( "0");
				else if( boxval1 == BoxValNone) ps( "/");
				else ps( "%d", boxval1);
				if( boxval2 == 10) ps( "0");
				else if( boxval2 == BoxValNone) ps( "?");
				else ps( "%d", boxval2);
			}
			else {
				BoxVal  boxval = get_boxval( row, col);
				if( boxval == 10) ps( "O");
				else ps( "%-.2s", ss+boxval*2);
			}
			if( get_boxval(row,col) != BoxValNone) n++;
		}
		ps( "|\n");
	}
	ps( "%s\n", m_rowline);
	ps( "萔 : %d \n", n);
}

