/**
 * {͎dŎgĂ郉CuȂ̂C
 * SJɂ͂Ȃ̂ŁCꕔ𔲐ČJ悤ƂC
 * \ςȂ̂ł炵ȒPɍĂ݂B
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#ifdef __unix__
#define stricmp strcasecmp
#define strnicmp strncasecmp
#endif

#include <string>
#include <set>
#include <map>
using namespace std;

class mt_string : public string {
public:
	mt_string(cstring s) : string(s) { }
	mt_string() {}
	operator cstring() const { return c_str();}
};

class mt_text_file {
public:
	mt_text_file( void);
  ~mt_text_file( void);
  YesNo open  ( cstring fileName); // ɑ݂t@CI[v,t@C݂Ȃꍇ̓G[
	cstring get_line();						// t@C̖NULLԂ
private:
	void close();
private:
	FILE*         m_fp;
	string        m_last_line;
};

class mt_token {
public:
	mt_token( cstring s, int n);
	int split( cstring s);
	int get_num_token();
	cstring operator[]( int idx);
private:
	set<char>   m_key;
	int           m_num_token;
	map<int,string>   m_token;
};

class mt_option {
public:
  mt_option( cstring opt1, cstring opt2, int argc, cstring argv[]);
  ~mt_option();
  long    get_long  ( char option, long    iDefault);
  int is_exist( char chr);
  cstring get_argument( int n);
private:
	set<char>         m_opt1;
	map<char,string>  m_option;
	map<int,string>   m_arg;
};

YesNo mt_strequal( cstring s1, cstring s2) { return !stricmp(s1,s2);}
YesNo mt_strnequal( cstring s1, cstring s2, int n) { return !strnicmp(s1,s2,n);}
inline YesNo mt_strleftequal( cstring s1, cstring s2, int n) {	return mt_strnequal(s1,s2,n);}
inline int mt_atoi( cstring s) { if( s != NULL) return    atoi(s);	return    0;}
YesNo mt_is_exist_file( cstring fileName); // fBNg̓t@CƌȂȂ̂Œӂ邱

mt_token::mt_token( cstring s, int n)
{
	while( *s) {
		m_key.insert( *s);
		s++;
	}
}

int mt_token::split( cstring s)
{
	cstring       p = s;
	string        token;
	int           n = 0;
	m_token.clear();
	while( *s) {
		if( m_key.find( *s) != m_key.end()) {
			token     = string(p,s-p);
			m_token.insert( pair<int,string>(n, token));
			n++;
			p         = s+1;
		}
		s++;
	}
	if( p != s) {
		token     = string(p,s-p);
		m_token.insert( pair<int,string>(n, token));
		n++;
	}
	m_num_token   = n;
	return    n;
}

int mt_token::get_num_token()
{
	return    m_num_token;
}

cstring mt_token::operator[]( int idx) 
{
	map<int,string>::iterator ite;
	ite = m_token.find( idx);
	if( ite == m_token.end()) {
		return    NULL;
	}
	return    (*ite).second.c_str();
}

mt_text_file::mt_text_file()
{
	m_fp          = NULL;
}

mt_text_file::~mt_text_file()
{
	close();
}

void mt_text_file::close()
{
	if( m_fp != NULL) {
		fclose(m_fp);
		m_fp        = NULL;
	}
}

YesNo mt_text_file::open( cstring fileName)
{
	close();
	if( (m_fp=fopen( fileName, "r")) == NULL) {
		return    NO;
	}
	return    YES;
}

cstring mt_text_file::get_line()
{
	if( m_fp == NULL) return    NULL;
	char          buf[10000];
	if( fgets( buf, sizeof(buf), m_fp) == NULL) {
		return    NULL;
	}
	astring p = buf;
	while( *p && *p != 0x0d && *p != 0x0a) {
		p++;
	}
	*p            = NIL;
	m_last_line   = buf;
	return    m_last_line.c_str();
}

YesNo mt_is_exist_file( cstring fn)
{
  struct stat fst;
  int r;

  r = stat( fn, &fst);
  if( !r) {
		return    YES;
  }
  else {
    return    NO;
  }
}

mt_option::mt_option( cstring opt1, cstring opt2, int argc, cstring argv[])
{
	int           n = 0;
	char          c;
	string        s1 = opt1;
	string        s2 = opt2;
	for( int i=1; i< argc; i++) {
		if( *argv[i] == '-') {
			c         = *(argv[i]+1);
			if( s1.find(c) != -1) {
				ps( "FIND(%c) in %s\n", c, s1.c_str());
				m_opt1.insert( c);
			}
			else if( s2.find(c) != -1) {
				m_option.insert( pair<char,string>( c, argv[i+1]));
				i++;
			}
		}
		else {
			m_arg.insert( pair<int,string>(n,argv[i]));
		}
	}
}

mt_option::~mt_option()
{
}

long mt_option::get_long( char option, long iDefault)
{
	map<char,string>::iterator ite;
	ite = m_option.find( option);
	if( ite == m_option.end()) return    iDefault;
	return    atoi((*ite).second.c_str());
}

int mt_option::is_exist( char chr)
{
	set<char>::iterator ite1;
	map<char,string>::iterator ite;
	ite1 = m_opt1.find( chr);
	if( ite1 != m_opt1.end()) return    YES;
	ite = m_option.find( chr);
	if( ite != m_option.end()) return    YES;
	return    NO;
}

cstring mt_option::get_argument( int n)
{
	map<int,string>::iterator ite;
	ite = m_arg.find( n);
	if( ite == m_arg.end()) return    NULL;
	return    (*ite).second.c_str();
}
